#include <iostream>
#include<vector>
#include<cmath>
#include<algorithm>
using namespace std;

int main()
{
    int N,Q;
    cin>>N>>Q;
    vector<long long int>d(N);
    vector<long long int>p(N);
    long long int zbir=0;
    for(int i=0;i<N;i++){
    cin>>d[i]>>p[i];
    zbir=zbir+p[i];
    }
    vector<long long int>k(Q);
    for(int j=0;j<Q;j++){
    cin>>k[j];
    }
    vector<pair<long long int, long long int>> dp(N);
    for (int i = 0; i < N; i++) {
        dp[i] = {d[i], p[i]};
    }
    sort(dp.begin(), dp.end());

    for(int j=0;j<Q;j++){
    long long int pojela=0;
    long long int pitanje=k[j];

    for(int i=0;i<N;i++){
    if(pitanje<dp[i].first){
        pojela=0;
        break;
    }
    else if(pitanje==dp[i].first){
        pojela=1;
        break;

    }
    else if(pitanje>dp[i].first){
            if(i>0){
        pojela=zbir-(dp[i-1].first+dp[i-1].second);
            }
            else{pojela=zbir;}
        break;
    }}
    cout<<pojela<<endl;
    }
    return 0;

}